// DOMContentLoaded event se okida kada se ucita ceo HTML dokument
document.addEventListener("DOMContentLoaded", () => {
	// Dohvatamo potrebne HTML elemente preko ID vrednosti
	const updateDayButton = document.getElementById("update-day");
	const currentDay = document.getElementById("current-day");
	const userForm = document.getElementById("user-form");

	// Dodajemo event listener na dugme za azuriranje dana
	updateDayButton.addEventListener("click", () => {
		const day = getCurrentDay();
		currentDay.textContent = day;
	});

	// Dodajemo event listener na formu za dodavanje korisnika
	userForm.addEventListener("submit", (event) => {
		// Sprecavamo podrazumevano ponasanje forme
		// da se stranica ne bi ponovo ucitavala
		event.preventDefault();
		// Dohvatamo vrednosti unete u formu
		const name = document.getElementById("name").value;
		const age = document.getElementById("age").value;
		addUser(name, age);
		updateUserTable();
		userForm.reset();
	});

	// Azuriramo tabelu korisnika prilikom ucitavanja stranice
	updateUserTable();
});
