// Definisanje sa kljucnom recju function
function zbir(a: number, b: number) {
	return a + b;
}

// Definisanje arrow funkcije
const razlika = (a: number, b: number) => {
	return a - b;
};

// Definisanje funkcije sa eksplicitnim tipom povratne vrednosti
function proizvod(a: number, b: number): number {
	return a * b;
}

// Definisanje arrow funkcije sa eksplicitnim tipom povratne vrednosti
const kolicnik = (a: number, b: number): number => {
	return a / b;
};

// Poziv funkcija
console.log(zbir(5, 3)); // 8
console.log(razlika(5, 3)); // 2
console.log(proizvod(5, 3)); // 15
console.log(kolicnik(5, 3)); // 1.6666666666666667

// void tip povratne vrednosti (moze i ne mora biti eksplicitno naveden)
function ispisPoruke(poruka: string): void {
	console.log(poruka);
}

ispisPoruke("Zdravo, svete!");

// Funkcija koja baca grešku ako je argument null
const baciGresku = (poruka: string | null) => {
	if (!poruka) {
		throw new Error("Poruka ne sme biti prazna");
	}
	console.log(poruka);
};

baciGresku("Ovo je poruka"); // Ovo je poruka

// Error: Poruka ne sme biti prazna
// Otkomentarisati sledeću liniju da bi se prikazala greška
// baciGresku(null);

// Funkcija sa opcionim argumentom
const pozdrav = (ime: string, prezime?: string): string => {
	if (prezime) {
		return `Zdravo, ${ime} ${prezime}`;
	} else {
		return `Zdravo, ${ime}`;
	}
};

console.log(pozdrav("Ana")); // Zdravo, Ana
console.log(pozdrav("Ana", "Anic")); // Zdravo, Ana Anic

// Funkcija sa podrazumevanim vrednostima
const zdravo = (ime: string = "nepoznati"): string => {
	return `Zdravo, ${ime}`;
};

console.log(zdravo()); // Zdravo, nepoznati
console.log(zdravo("Marko")); // Zdravo, Marko

const danasnjeVreme = {
	datum: new Date(),
	vreme: "toplo",
};

// Funkcija sa objektom kao argumentom
// Objekat mora imati svojstva datum i vreme
const ispisVremena = ({
	datum,
	vreme,
}: {
	datum: Date;
	vreme: string;
}): void => {
	console.log(datum);
	console.log(vreme);
};

ispisVremena(danasnjeVreme);
