class Vozilo {
	// Konstruktor je metoda koja se poziva prilikom kreiranja instance klase
	// Ovo je kraci zapis za sledeci kod:
	// public boja: string;
	// constructor(boja: string) {
	// 	 this.boja = boja;
	// }
	constructor(public boja: string) {}

	// Protected metode mogu biti pozvane iz klase u kojoj su definisane i iz klasa koje nasledjuju tu klasu
	protected sviraj(): void {
		console.log("bip bip");
	}
}

// Kreiranje instance klase
const vozilo = new Vozilo("crvena");
console.log(vozilo.boja);

// Nasledjivanje klase
class Auto extends Vozilo {
	// Konstruktor klase Auto
	// Ovde se koristi super metoda koja poziva konstruktor klase koja se nasledjuje
	// Ovo je kraci zapis za sledeci kod:
	// public tockovi: number;
	// constructor(tockovi: number, boja: string) {
	// 	 super(boja);
	// 	 this.tockovi = tockovi;
	// }
	constructor(public tockovi: number, boja: string) {
		super(boja);
	}

	// Private metode mogu biti pozvane samo iz klase u kojoj su definisane
	private vozi(): void {
		console.log("brm brm");
	}

	// Ako se ne navede pristupni modifikator, podrazumeva se public
	// Public znaci da se metoda moze pozvati izvan klase
	zapocniVoznju(): void {
		// this je referenca na trenutnu instancu klase
		this.vozi();
		this.sviraj();
	}
}

// Kreiranje instance klase Auto
const auto = new Auto(4, "crvena");
auto.zapocniVoznju();
