import { FunctionComponent } from "react";
// Importujemo komponentu UserCard
import UserCard from "./UserCard";

// Interface koji definiše tipove za objekat korisnika
interface User {
	isMale: boolean;
	name: string;
	description: string;
	profileUrl: string;
}

// Niz korisnika sa potrebnim svojstvima
const users: User[] = [
	{
		isMale: true,
		name: "Petar Petrović",
		description: "Petar Petrović je inženjer elektrotehnike.",
		profileUrl: "https://www.example.com/profile/petar.petrovic",
	},
	{
		isMale: false,
		name: "Ana Anić",
		description: "Ana Anić je profesorka matematike.",
		profileUrl: "https://www.example.com/profile/ana.anic",
	},
	{
		isMale: true,
		name: "Marko Marković",
		description: "Marko Marković je programer.",
		profileUrl: "https://www.example.com/profile/marko.markovic",
	},

	{
		isMale: false,
		name: "Jelena Jelić",
		description: "Jelena Jelić je doktorka.",
		profileUrl: "https://www.example.com/profile/jelena.jelic",
	},
];

// Komponenta App koja prikazuje sve kartice korisnika
const App: FunctionComponent = () => {
	return (
		<div className="container mt-5">
			<h1 className="text-center mb-5">Profili korisnika</h1>
			<div className="row">
				{/* Prolazimo kroz niz korisnika i za svakog kreiramo karticu */}
				{users.map((user, index) => (
					<UserCard
						/* Prosleđujemo potrebne podatke komponenti UserCard */
						/* Jedinstven ključ je potreban kako bi React mogao efikasno da ažurira komponente */
						key={index}
						isMale={user.isMale}
						name={user.name}
						description={user.description}
						profileUrl={user.profileUrl}
					/>
				))}
			</div>
		</div>
	);
};

export default App;
